/**
 * @file libtransistor/modules/err.h
 * @brief Error module definitions
 */

#pragma once

#ifdef __cplusplus
extern "C" {
#endif

enum modules {
	MODULE_KERNEL = 1,
	MODULE_FS = 2,
	MODULE_NVIDIA = 3,
	MODULE_NCM = 5,
	MODULE_DD = 6,
	MODULE_LR = 8,
	MODULE_LOADER = 9,
	MODULE_CMIF = 10,
	MODULE_HIPC = 11,
	MODULE_PM = 15,
	MODULE_NS = 16,
	MODULE_HTC = 18,
	MODULE_SM = 21,
	MODULE_RO = 22,
	MODULE_SDMMC = 24,
	MODULE_SPL = 26,
	MODULE_ETHC = 100,
	MODULE_I2C = 101,
	MODULE_SETTINGS = 105,
	MODULE_NIFM = 110,
	MODULE_HWOPUS = 111,
	MODULE_DISPLAY = 114,
	MODULE_NTC = 116,
	MODULE_FGM = 117,
	MODULE_PCIE = 120,
	MODULE_FRIENDS = 121,
	MODULE_SSL = 123,
	MODULE_ACCOUNT = 124,
	MODULE_MII = 126,
	MODULE_AM = 128,
	MODULE_PLAYREPORT = 129,
	MODULE_PCV = 133,
	MODULE_OMM = 134,
	MODULE_NIM = 137,
	MODULE_PSC = 138,
	MODULE_USB = 140,
	MODULE_NSD = 141,
	MODULE_BTM = 143,
	MODULE_ERPT = 147,
	MODULE_APM = 148,
	MODULE_AUDIO = 153,
	MODULE_NPNS = 154,
	MODULE_ARP = 157,
	MODULE_BOOT = 158,
	MODULE_NFC = 161,
	MODULE_USERLAND_ASSERT = 162,
	MODULE_USERLAND_CRASH = 168,
	MODULE_HID = 203,
	MODULE_CAPTURE = 206,
	MODULE_LIBTRANSISTOR = 221,
	MODULE_LIBNX = 345,
	MODULE_HOMEBREW_ABI = 346,
	MODULE_HOMEBREW_LOADER = 347,
	MODULE_LIBNX_NVIDIA = 348,
	MODULE_TC = 651,
	MODULE_WEBAPPLET = 800,
	MODULE_WEBAPPLET_WIFIAUTH = 809,
	MODULE_APPLET_WHITELISTED = 810,
	MODULE_SHOPN = 811,
};

#ifdef __cplusplus
}
#endif
